Arbor 3: FSM & BT Graph Editor 3.7.8

Public Member Functions | Protected Member Functions | Properties | List of all members
TreeBehaviourNode Class Reference

Base class of node with TreeNodeBehaviour More...

Inheritance diagram for TreeBehaviourNode:

## Public Member Functions
| TreeBehaviourNode (NodeGraph nodeGraph, int nodeID)
| TreeBehaviourNode constructor More...
Object | GetBehaviourObject ()
| Get Main Behaviour Object. More...
Decorator | AddDecorator (System.Type type)
| Adds the Decorator. More...
T | AddDecorator< T > ()
| Adds the Decorator. More...
Decorator | InsertDecorator (int index, System.Type type)
| Insert the Decorator. More...
T | InsertDecorator< T > (int index)
| Insert the Decorator. More...
Service | AddService (System.Type type)
| Adds the Service. More...
T | AddService< T > ()
| Adds the Service. More...
Service | InsertService (int index, System.Type type)
| Insert the Service. More...
T | InsertService< T > (int index)
| Insert the Service. More...
override bool | IsContainsBehaviour (NodeBehaviour behaviour)
| Check if it contains NodeBehaviour. More...
void | MoveDecorator (int fromIndex, TreeBehaviourNode toNode, int toIndex)
| Move the order of Decorator. More...
void | MoveService (int fromIndex, TreeBehaviourNode toNode, int toIndex)
| Move the order of Service. More...
void | DestroyBehaviour ()
| Destroy behaviour. More...
void | DestroyAllBehaviour ()
| Destroy all behaviour. More...
Public Member Functions inherited from TreeNodeBase
| TreeNodeBase (NodeGraph nodeGraph, int nodeID)
| TreeNodeBase constructor More...
abstract bool | HasParentLinkSlot ()
| Whether this node has a NodeLinkSlot to parent. More...
virtual NodeLinkSlot | GetParentLinkSlot ()
| Get NodeLinkSlot to parent. More...
abstract bool | HasChildLinkSlot ()
| Whether this node has a NodeLinkSlot to child. More...
override bool | IsDeletable ()
| Returns whether or not it can be deleted. More...
override string | ToString ()
| Convert node to string (for debugging). More...
Public Member Functions inherited from Node
| Node (NodeGraph nodeGraph, int nodeID)
| Node constructor More...
virtual string | GetName ()
| Get node name. More...
override string | ToString ()
| Convert node to string (for debugging). More...

## Protected Member Functions
override void | OnGraphChanged ()
| Called when the NodeGraph to which the Node belongs has changed. More...
void | SetBehaviour (TreeNodeBehaviour behaviour)
| Set Main Behaviour. More...
Protected Member Functions inherited from TreeNodeBase
abstract void | OnExecute ()
| Called when executing. More...

## Properties
TreeNodeBehaviour | behaviour`[get]`
| Main behaviour More...
DecoratorList | decoratorList`[get]`
| Decorator list More...
ServiceList | serviceList`[get]`
| Service list More...
bool | breakPoint`[get, set]`
| Break point. More...
Properties inherited from TreeNodeBase
bool | enablePriority`[get]`
| Returns true if it is traced from the root node and connected. More...
int | priority`[get]`
| The priority of the node. More...
BehaviourTreeInternal | behaviourTree`[get]`
| Gets the behaviour tree. More...
TreeNodeBase | parentNode`[get]`
| Get parent node. More...
NodeStatus | status`[get]`
| The state of the node. More...
bool | isActive`[get]`
| Returns true if it is active. More...
Properties inherited from Node
NodeGraph | nodeGraph`[get]`
| Gets the NodeGraph. More...
int | nodeID`[get]`
| Gets the node identifier. More...

## Additional Inherited Members
Public Attributes inherited from Node
Rect | position
| Position on the Arbor Editor. More...
bool | showComment
| Whether to display comments More...
string | nodeComment
| Comment More...

## Detailed Description

Base class of node with TreeNodeBehaviour

## Constructor & Destructor Documentation

## ◆ TreeBehaviourNode()

TreeBehaviourNode | ( | NodeGraph | nodeGraph,
|  | int | nodeID
| ) |  |

TreeBehaviourNode constructor

Parameters

  nodeGraph | NodeGraph with this node
  nodeID | Node ID

## Member Function Documentation

## ◆ AddDecorator()

Decorator AddDecorator | ( | System.Type | type | ) |

Adds the Decorator.

Parameters

  type | Type of add Decorator

Returns
  Added Decorator

## ◆ AddDecorator< T >()

T AddDecorator< T > | ( |  | ) |

Adds the Decorator.

Template Parameters

  T | Type of add Decorator

Returns
  Added Decorator

Type Constraints

  T | : | Decorator |

## ◆ AddService()

Service AddService | ( | System.Type | type | ) |

Adds the Service.

Parameters

  type | Type of add Service

Returns
  Added Service

## ◆ AddService< T >()

T AddService< T > | ( |  | ) |

Adds the Service.

Template Parameters

  T | Type of add Service

Returns
  Added Service

Type Constraints

  T | : | Service |

## ◆ DestroyAllBehaviour()

void DestroyAllBehaviour | ( |  | ) |

Destroy all behaviour.

## ◆ DestroyBehaviour()

void DestroyBehaviour | ( |  | ) |

Destroy behaviour.

## ◆ GetBehaviourObject()

Object GetBehaviourObject | ( |  | ) |

Get Main Behaviour Object.

Returns
  Main Behaviour Object

## ◆ InsertDecorator()

Decorator InsertDecorator | ( | int | index,
|  | System.Type | type
| ) |  |

Insert the Decorator.

Parameters

  index | Insertion destination index
  type | Type of add Decorator

Returns
  Inserted Decorator

## ◆ InsertDecorator< T >()

T InsertDecorator< T > | ( | int | index | ) |

Insert the Decorator.

Template Parameters

  T | Type of insert Decorator

Parameters

  index | Insertion destination index

Returns
  Inserted Decorator

Type Constraints

  T | : | Decorator |

## ◆ InsertService()

Service InsertService | ( | int | index,
|  | System.Type | type
| ) |  |

Insert the Service.

Parameters

  index | Insertion destination index
  type | Type of add Service

Returns
  Inserted Service

## ◆ InsertService< T >()

T InsertService< T > | ( | int | index | ) |

Insert the Service.

Template Parameters

  T | Type of insert Service

Parameters

  index | Insertion destination index

Returns
  Inserted Service

Type Constraints

  T | : | Service |

## ◆ IsContainsBehaviour()

override bool IsContainsBehaviour | ( | NodeBehaviour | behaviour | ) |
| virtual

Check if it contains NodeBehaviour.

Parameters

  behaviour | Check NodeBehaviour

Returns
  Returns true if it contains NodeBehaviour.

Reimplemented from Node.

## ◆ MoveDecorator()

void MoveDecorator | ( | int | fromIndex,
|  | TreeBehaviourNode | toNode,
|  | int | toIndex
| ) |  |

Move the order of Decorator.

Parameters

  fromIndex | The moving want index.
  toNode | The destination Node.
  toIndex | The destination index.

## ◆ MoveService()

void MoveService | ( | int | fromIndex,
|  | TreeBehaviourNode | toNode,
|  | int | toIndex
| ) |  |

Move the order of Service.

Parameters

  fromIndex | The moving want index.
  toNode | The destination Node.
  toIndex | The destination index.

## ◆ OnGraphChanged()

override void OnGraphChanged | ( |  | ) |
| protected virtual

Called when the NodeGraph to which the Node belongs has changed.

Reimplemented from Node.

## ◆ SetBehaviour()

void SetBehaviour | ( | TreeNodeBehaviour | behaviour | ) |
| protected

Set Main Behaviour.

Parameters

  behaviour | Behaviour

## Property Documentation

## ◆ behaviour

TreeNodeBehaviour behaviour
| get

Main behaviour

## ◆ breakPoint

bool breakPoint
| get set

Break point.

When this property is true, the editor will be paused when the node becomes active.

## ◆ decoratorList

DecoratorList decoratorList
| get

Decorator list

## ◆ serviceList

ServiceList serviceList
| get

Service list